#! python2.6
# http://www.onlinewahn.de/ober-h-r.htm

# grundlage schaffen

alle = {}
kandidat = {}
summe = {}
produkt = {}
differenz = {}

for i in range(1, 1001):
    for j in range(1, 1001):
        if (i, j) not in kandidat and (j, i) not in kandidat:
            alle[(i, j)] = True
            kandidat[(i, j)] = True
            
            if (i + j) not in summe:
                summe[(i + j)] = []
            summe[(i + j)] += [(i, j)]

            if (i * j) not in produkt:
                produkt[(i * j)] = []
            produkt[(i * j)] += [(i, j)]

            if (i - j) not in differenz:
                differenz[(i - j)] = []
            differenz[(i - j)] += [(i, j)]

print 'moegliche kandidaten: ', len(kandidat) 

# fuer jedes produkt pruefen, wie oft es vorkommt, wenn einmal, dann ausschliessen

for p, c in produkt.items():
    if len(c) == 1:
        del kandidat[c[0]]

print 'moegliche kandidaten: ', len(kandidat)

# jede summe pruefen, wenn nur ein moegliches produkt eindeutig ist: verwerfen, also alle kandidaten dieser summe verwerfen

for s, all_c in summe.items():
    for c in all_c:
        if len(produkt[c[0] * c[1]]) == 1:
            for d in all_c:
                if d in kandidat:
                    del kandidat[d]
            break
            
print 'moegliche kandidaten: ', len(kandidat)

# p kennt das produkt, das heisst, /jetzt/ ist es eindeutig geworden, /jetzt/ hat es fuer sein produkt nur noch einen einen kandidat
# somit: alle produkte neu rechnen mit kandidat, dann die ausschliessen, die nicht eindeutig sind

produkt = {}
for c in kandidat:
    i, j = c
    if (i * j) not in produkt:
        produkt[(i * j)] = []
    produkt[(i * j)] += [(i, j)]
    
for p, all_c in produkt.items():
    if len(all_c) > 1:
        for d in all_c:
            if d in kandidat:
                del kandidat[d]

print 'moegliche kandidaten: ', len(kandidat)

# alle summen neu rechnen mit kandidat, dann die ausschliessen, die nicht eindeutig sind

summe = {}
for c in kandidat:
    i, j = c
    if (i + j) not in summe:
        summe[(i + j)] = []
    summe[(i + j)] += [(i, j)]
    
for p, all_c in summe.items():
    if len(all_c) > 1:
        for d in all_c:
            if d in kandidat:
                del kandidat[d]

print 'moegliche kandidaten: ', len(kandidat)

# alle differenzen nochmal rechnen, dann die ausschliessen, die nicht eindeutig sind

differenz = {}
for c in kandidat:
    i, j = c
    if (i - j) not in differenz:
        differenz[(i - j)] = []
    differenz[(i - j)] += [(i, j)]

for p, all_c in differenz.items():
    if len(all_c) == 1:
        for d in all_c:
            if d in kandidat:
                del kandidat[d]

print 'moegliche kandidaten: ', len(kandidat)

# bestimmen, welche zahlen zu einer differenz gehoeren und schliesse alle kandidaten aus, die keine haeufung haben 

differenz_z = {}
for c in kandidat:
    i, j = c
    if (i - j) not in differenz_z:
        differenz_z[(i - j)] = []
    differenz_z[(i - j)] += [i, j]

for d, z in differenz_z.items():
    if len(z) == len(set(z)):
        for c in differenz[d]:
            del kandidat[c]
    else:
        # unschoen: nehme einfach die letzte ;)
        schaetzung = {}
        for i in z: schaetzung[i] = 0
        for i in z: schaetzung[i] += 1
        schaetzung = sorted([(value,key) for (key,value) in schaetzung.items()])
        schaetzung_d = d
        schaetzung_z = schaetzung[-1][1]


print 'moegliche kandidaten: ', len(kandidat)

# bei den letzten kandidaten die streichen, welche die gehaeufte zahl enthalten 

for c in differenz[schaetzung_d]:
    if schaetzung_z in c:
        del kandidat[c]

print 'ergebnis: ', kandidat.keys()[0]
